## For Continuous Deployment Using Jenkins with Maven and Tomcat

1. Create an instance of an EC2 (Amazon Linux 2 AMI). Make sure your security groups are configured to allow ssh to port 22, and tcp traffic to port 8080 and 8090.

2. Connect to you EC2 using ssh.

   > ssh -i [pem file] ec2-user@[public ip]

3. Install git

   > sudo yum install git -y

4. Clone this repository onto your EC2

   > git clone https://gitlab.com/210614-java-react-enterprise/training-repositories/devops-scripts.git

5. Navigate into the project folder and execute install script. Select Java 8 when prompted.

   > cd devops-script
   > sh install.sh

This script will install Maven and Java. Tomcat is running on port 8090, and Jenkins is on 8080.

6. Go to Jenkins on port 8080. Use the `cat` command to print the contents of the initialAdminPassword, install the suggested plugins, and set up an admin user.

   See [jenkinsfile-examples](https://github.com/carolynrehm/devops-script/tree/master/jenkinsfile-examples) for relevant pipeline scripts for your desired jobs. The Jenkinsfile we used is included in this repo. Also, make sure as you configure your jobs, limit the number of old builds to 1 or 2 so your EC2 doesn't have memory issues.

7. You will need to configure jenkins with your gitlab credentials if you're working with a private repo. To do this, navigate to Jenkins homepage and then to "Credentials" on the left side of the landing page. Select your global domain under your stores, and then select "Add Credentials." From here, include your gitlab username and password. Once you click okay, an ID will be generated by Jenkins representing these credentials. This is your "credentialsId" in your Jenkinsfile.

8. Make sure to add your webhook to your GitLab repository. This must be done with the GitLab Plugin. To install it, navigate to "Manage Jenkins">"Manage Plugins" and find it under "Available."

- Once installed, a webhook must be created in your GitLab repository which is authenticated using a Jenkins API token.
- This is best done with another user (non-admin user with Read + Job/Build permissions)
  - user is created under "Manage Jenkins">"Manage Users"
  - permissions are set under "Manage Jenkins">"Configure Global Security" using Matrix-based security
    - add the user you created to the matrix
    - select Overall Read and Job Build
    - save changes
- Log in as your user and generate API key
  - click on the name of your user on the upper right-hand corner of jenkins, and select Configure
  - generate an API token
  - copy and paste this token, store it in a safe place
- Go to your GitLab repository and configure a webhook
  - navigate to the repo, then "Settings">"Webhooks"
  - the url should be formatted as http://[username]:[api token]@[ec2 ip]:8080/project/[project name]
- the build trigger needs also to be enabled in the configuration of the jenkins job
  - because of the GitLab Plugin, there should now be a GitLab build trigger. Select this option
- See [gitlab docs](https://docs.gitlab.com/ee/user/gitlab_com/#ip-range) for the proper IP's to allow traffic from

--- Adding in additional secrets to jenkins ---
In order to add additional secure values to your jenkins build through jenkins, you can add "secret text" to your credential manager and then access those values within your Jenkinsfile. To do this, navigate to the credential manager (see 7), but instead of choosing username/password, select "secret text." This will allow you to securely store things like your db url, username, and password. In order to access these in your script, create an environment variable and assign it to credentials('credentialsId').
